$(() => {
const products = new DevExpress.data.DataSource({
store: productsData,
key: 'id',
group: 'Category',
});
$('#TagBox').dxTagBox({
dataSource: products,
valueExpr: 'ID',
value: [productsData[16].ID, productsData[18].ID],
grouped: true,
displayExpr: 'Name',
});
$('#TagBoxSearch').dxTagBox({
dataSource: products,
valueExpr: 'ID',
value: [productsData[16].ID, productsData[18].ID],
searchEnabled: true,
grouped: true,
displayExpr: 'Name',
});
$('#TagBoxTemplate').dxTagBox({
dataSource: products,
valueExpr: 'ID',
value: [productsData[17].ID],
grouped: true,
groupTemplate(data) {
return $(`<div class='custom-icon'><span class='dx-icon-box icon'></span> ${data.key}</div>`);
},
displayExpr: 'Name',
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Grouped items</div>
<div class="dx-field-value">
<div id="TagBox"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Grouped items with search enabled</div>
<div class="dx-field-value">
<div id="TagBoxSearch"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Grouped items with a custom group template</div>
<div class="dx-field-value">
<div id="TagBoxTemplate"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.custom-icon .icon {
font-size: 17px;
color: #f05b41;
margin-right: 2px;
}
.dx-field {
margin-bottom: 50px;
}
const productsData = [{
ID: 1,
Name: 'HD Video Player',
Category: 'Video Players',
}, {
ID: 2,
Name: 'SuperHD Player',
Category: 'Video Players',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Category: 'Televisions',
}, {
ID: 4,
Name: 'SuperLED 50',
Category: 'Televisions',
}, {
ID: 5,
Name: 'SuperLED 42',
Category: 'Televisions',
}, {
ID: 6,
Name: 'SuperLCD 55',
Category: 'Televisions',
}, {
ID: 7,
Name: 'SuperLCD 42',
Category: 'Televisions',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Category: 'Televisions',
}, {
ID: 9,
Name: 'SuperLCD 70',
Category: 'Televisions',
}, {
ID: 10,
Name: 'DesktopLED 21',
Category: 'Monitors',
}, {
ID: 11,
Name: 'DesktopLED 19',
Category: 'Monitors',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Category: 'Monitors',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Category: 'Monitors',
}, {
ID: 14,
Name: 'Projector Plus',
Category: 'Projectors',
}, {
ID: 15,
Name: 'Projector PlusHD',
Category: 'Projectors',
}, {
ID: 16,
Name: 'Projector PlusHT',
Category: 'Projectors',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Category: 'Automation',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Category: 'Automation',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Category: 'Automation',
}];

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Grouped Items

The TagBox component can arrange items into a two-level parent-child hierarchy. To group items, set the grouped property to true and ensure the data source defines the hierarchy in one of the following ways:

  • Grouping Field
    The data source can contain a plain array of objects with multiple fields. Assign a field to the DataSource's group property to create a hierarchical display. Parent items display unique values from the specified field, and Child items display grouped values. This demo shows how to use this data source type.

  • Hierarchical Data Source Structure
    You can use a dataSource where each entry is an object that contains the key and items fields. The key field specifies the group header (parent), and the items field holds an array of child items. A data source can specify different field names if the data is structured in the same way. In this case, implement the DataSource's map function to create key and items field mappings. Refer to the following help topic for more information: Item Mapping.

This demo also shows how to customize the appearance of group headers (the groupTemplate property) and enable search (the searchEnabled property).

Backend API
<template> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label"> Grouped items </div> <div class="dx-field-value"> <DxTagBox :data-source="products" :input-attr="{ 'aria-label': 'Product' }" :value="[17, 19]" :grouped="true" display-expr="Name" value-expr="ID" /> </div> </div> <div class="dx-field"> <div class="dx-field-label"> Grouped items with search enabled </div> <div class="dx-field-value"> <DxTagBox :data-source="products" :value="[17, 19]" :grouped="true" :input-attr="{ 'aria-label': 'Product' }" :search-enabled="true" display-expr="Name" value-expr="ID" /> </div> </div> <div class="dx-field"> <div class="dx-field-label"> Grouped items with a custom group template </div> <div class="dx-field-value"> <DxTagBox :data-source="products" :input-attr="{ 'aria-label': 'Product' }" :value="[18]" :grouped="true" display-expr="Name" value-expr="ID" > <template #group="{ data }"> <Group :item-data="data"/> </template> </DxTagBox> </div> </div> </div> </template> <script setup lang="ts"> import { DxTagBox } from 'devextreme-vue/tag-box'; import Group from './Group.vue'; import productsData from './data.ts'; const products = { store: productsData, key: 'ID', group: 'Category', }; </script> <style scoped> .dx-field { margin-bottom: 50px; } </style>
<template> <div class="custom-icon"> <span class="dx-icon-box icon"/> {{ itemData.key }} </div> </template> <script setup lang="ts"> withDefaults(defineProps<{ itemData?: {[key:string]: unknown} }>(), { itemData: () => ({ key: '' }), }); </script> <style scoped> .custom-icon .icon { font-size: 17px; color: #f05b41; margin-right: 2px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'root:': '../../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme-vue': 'npm:devextreme-vue@23.2.5/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
export default [{ ID: 1, Name: 'HD Video Player', Category: 'Video Players', }, { ID: 2, Name: 'SuperHD Player', Category: 'Video Players', }, { ID: 3, Name: 'SuperPlasma 50', Category: 'Televisions', }, { ID: 4, Name: 'SuperLED 50', Category: 'Televisions', }, { ID: 5, Name: 'SuperLED 42', Category: 'Televisions', }, { ID: 6, Name: 'SuperLCD 55', Category: 'Televisions', }, { ID: 7, Name: 'SuperLCD 42', Category: 'Televisions', }, { ID: 8, Name: 'SuperPlasma 65', Category: 'Televisions', }, { ID: 9, Name: 'SuperLCD 70', Category: 'Televisions', }, { ID: 10, Name: 'DesktopLED 21', Category: 'Monitors', }, { ID: 11, Name: 'DesktopLED 19', Category: 'Monitors', }, { ID: 12, Name: 'DesktopLCD 21', Category: 'Monitors', }, { ID: 13, Name: 'DesktopLCD 19', Category: 'Monitors', }, { ID: 14, Name: 'Projector Plus', Category: 'Projectors', }, { ID: 15, Name: 'Projector PlusHD', Category: 'Projectors', }, { ID: 16, Name: 'Projector PlusHT', Category: 'Projectors', }, { ID: 17, Name: 'ExcelRemote IR', Category: 'Automation', }, { ID: 18, Name: 'ExcelRemote BT', Category: 'Automation', }, { ID: 19, Name: 'ExcelRemote IP', Category: 'Automation', }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.3.4/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/typescript@4.2.4/lib/typescript.js"></script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

import React from 'react';
import { TagBox } from 'devextreme-react/tag-box';
import DataSource from 'devextreme/data/data_source';
import Group from './Group.js';
import productsData from './data.js';
const defaultValues = {
grouped: [17, 19],
search: [17, 19],
template: [18],
};
class App extends React.Component {
constructor() {
super();
this.products = new DataSource({
store: productsData,
key: 'ID',
group: 'Category',
});
}
render() {
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Grouped items</div>
<div className="dx-field-value">
<TagBox
dataSource={this.products}
valueExpr="ID"
defaultValue={defaultValues.grouped}
grouped={true}
displayExpr="Name" />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Grouped items with search enabled</div>
<div className="dx-field-value">
<TagBox
dataSource={this.products}
valueExpr="ID"
defaultValue={defaultValues.search}
searchEnabled={true}
grouped={true}
displayExpr="Name" />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Grouped items with a custom group template</div>
<div className="dx-field-value">
<TagBox
dataSource={this.products}
valueExpr="ID"
defaultValue={defaultValues.template}
grouped={true}
displayExpr="Name"
groupRender={Group} />
</div>
</div>
</div>
);
}
}
export default App;
import React from 'react';
export default function Group({ key }) {
return (
<div className="custom-icon">
<span className="dx-icon-box icon"></span>{' '}
{key}
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.custom-icon .icon {
font-size: 17px;
color: #f05b41;
margin-right: 2px;
}
.dx-field {
margin-bottom: 50px;
}
export default [{
ID: 1,
Name: 'HD Video Player',
Category: 'Video Players',
}, {
ID: 2,
Name: 'SuperHD Player',
Category: 'Video Players',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Category: 'Televisions',
}, {
ID: 4,
Name: 'SuperLED 50',
Category: 'Televisions',
}, {
ID: 5,
Name: 'SuperLED 42',
Category: 'Televisions',
}, {
ID: 6,
Name: 'SuperLCD 55',
Category: 'Televisions',
}, {
ID: 7,
Name: 'SuperLCD 42',
Category: 'Televisions',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Category: 'Televisions',
}, {
ID: 9,
Name: 'SuperLCD 70',
Category: 'Televisions',
}, {
ID: 10,
Name: 'DesktopLED 21',
Category: 'Monitors',
}, {
ID: 11,
Name: 'DesktopLED 19',
Category: 'Monitors',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Category: 'Monitors',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Category: 'Monitors',
}, {
ID: 14,
Name: 'Projector Plus',
Category: 'Projectors',
}, {
ID: 15,
Name: 'Projector PlusHD',
Category: 'Projectors',
}, {
ID: 16,
Name: 'Projector PlusHT',
Category: 'Projectors',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Category: 'Automation',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Category: 'Automation',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Category: 'Automation',
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.1.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Grouped items</div>
<div class="dx-field-value">
<dx-tag-box
[dataSource]="simpleProducts"
valueExpr="ID"
[value]="[17, 19]"
[grouped]="true"
displayExpr="Name">
</dx-tag-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Grouped items with search enabled</div>
<div class="dx-field-value">
<dx-tag-box
[dataSource]="simpleProducts"
valueExpr="ID"
[value]="[17, 19]"
[grouped]="true"
displayExpr="Name"
[searchEnabled]="true">
</dx-tag-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Grouped items with a custom group template</div>
<div class="dx-field-value">
<dx-tag-box
[dataSource]="simpleProducts"
valueExpr="ID"
[value]="[18]"
[grouped]="true"
displayExpr="Name"
searchEnabled="true"
groupTemplate="group"
>
<div *dxTemplate="let data of 'group'">
<div class='custom-icon'>
<span class='dx-icon-box icon'></span>
{{data.key}}
</div>
</div>
</dx-tag-box>
</div>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import {BrowserModule} from '@angular/platform-browser';
import {platformBrowserDynamic} from '@angular/platform-browser-dynamic';
import DataSource from 'devextreme/data/data_source';
import ArrayStore from 'devextreme/data/array_store';
import {
DxTagBoxModule
} from 'devextreme-angular';
import {Product, Service} from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
simpleProducts: DataSource;
data: any;
constructor(service: Service) {
this.simpleProducts = new DataSource({
store: new ArrayStore({
data: service.getProducts(),
key: "id",
}),
group: "Category"
});
}
}
@NgModule({
imports: [
BrowserModule,
DxTagBoxModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {
}
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .custom-icon .icon {
font-size: 17px;
color: #f05b41;
margin-right: 2px;
}
::ng-deep .dx-field {
margin-bottom: 50px;
}
import {Injectable} from '@angular/core';
export class Product {
ID: number;
Name: string;
Category: string;
}
let products: Product[] = [{
"ID": 1,
"Name": "HD Video Player",
"Category": "Video Players"
}, {
"ID": 2,
"Name": "SuperHD Player",
"Category": "Video Players"
}, {
"ID": 3,
"Name": "SuperPlasma 50",
"Category": "Televisions"
}, {
"ID": 4,
"Name": "SuperLED 50",
"Category": "Televisions"
}, {
"ID": 5,
"Name": "SuperLED 42",
"Category": "Televisions"
}, {
"ID": 6,
"Name": "SuperLCD 55",
"Category": "Televisions"
}, {
"ID": 7,
"Name": "SuperLCD 42",
"Category": "Televisions"
}, {
"ID": 8,
"Name": "SuperPlasma 65",
"Category": "Televisions"
}, {
"ID": 9,
"Name": "SuperLCD 70",
"Category": "Televisions"
}, {
"ID": 10,
"Name": "DesktopLED 21",
"Category": "Monitors"
}, {
"ID": 11,
"Name": "DesktopLED 19",
"Category": "Monitors"
}, {
"ID": 12,
"Name": "DesktopLCD 21",
"Category": "Monitors"
}, {
"ID": 13,
"Name": "DesktopLCD 19",
"Category": "Monitors"
}, {
"ID": 14,
"Name": "Projector Plus",
"Category": "Projectors"
}, {
"ID": 15,
"Name": "Projector PlusHD",
"Category": "Projectors"
}, {
"ID": 16,
"Name": "Projector PlusHT",
"Category": "Projectors"
}, {
"ID": 17,
"Name": "ExcelRemote IR",
"Category": "Automation"
}, {
"ID": 18,
"Name": "ExcelRemote BT",
"Category": "Automation"
}, {
"ID": 19,
"Name": "ExcelRemote IP",
"Category": "Automation"
}];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18',
'devextreme-angular': 'npm:devextreme-angular@20.2.5',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>